<?php

/**
 * destino actions.
 *
 * @package    controlComisiones
 * @subpackage destino
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class destinoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_DESTINO_V', 'COM_COMISION', 
        'PROYECTOS', 'TIPOS_COMISION', 
        'AREA', 
        'COM_TIPO_DESTINO', 'COM_TERCERO', 
        'COM_TIPO_COMISIONADO', 
        'TRANSPORTES',
        'MUNICIPIOS'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_DESTINO_V'
        )
        , 'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'AREA' =>
        array(
            'id_area' => 'COM_COMISION'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'id_tipo_destino' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_DESTINO_V'
        ),
        'COM_TIPO_COMISIONADO' =>
        array(
            'tipter' => 'COM_TERCERO'
        ),
        'TRANSPORTES' =>
        array(
            'id_tipo_transporte-id' => 'COM_DESTINO_V'
        ),
        'MUNICIPIOS, LEFT' =>
        array(
            'destino_fin-codmun' => 'COM_DESTINO_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_DESTINO_V' =>
        array(
            'id_destino' => 'id_destino',
            'id_comision' => 'id_comision',
            'id_tercero' => 'id_tercero',
            'destino_ini' => 'destino_ini',
            'destino_fin' => 'destino_fin',
            'id_tipo_transporte' => 'id_tipo_transporte',
            'municipio_ini' => 'municipio_ini',
            'municipio_fin' => 'municipio_fin',
            'observaciones' => 'observaciones'
        )
        ,
        'COM_COMISION' =>
        array(
            'id_anhos' => 'id_anhos',
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_tipo_destino' => 'id_tipo_destino',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
            'id_area' => 'id_area',
            'id_tipo_comision' => 'id_tipo_comision',
            'id_original' => 'id_original',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'activo' => 'activo'
        )
        ,
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'tipo_comision'
        ),
        'AREA' =>
        array(
            'descripcion' => 'area'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'descripcion' => 'tipo_destino'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'email' => 'email'
        ),
        'TRANSPORTES' =>
        array(
            'descripcion' => 'tipo_transporte'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_DESTINO_V' =>
        array(
            'id_destino,a' => array('!=' => array(-1)),
            'id_destino,b' => array('=' => array('id_destino')),
            'id_comision' => array('=' => array('id_comision')),
            'id_tercero' => array('=' => array('id_tercero')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => array('=' => array('num_doc'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_destino'; //identificador de la tabla
    protected $id_names = array('id_destino'); //llave primaria
    protected $field_names = array('id_comision', 'id_tercero', 'destino_ini', 'destino_fin', 'id_tipo_transporte','observaciones'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_DESTINO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_destino'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $this->conn->commit();
            } catch (Exception $e) {



                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $this->conn->commit();
            } catch (Exception $e) {



                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_comision = $request['id_comision'];
        $id_tercero = $request['id_tercero'];
        $destino_ini = $request['destino_ini'];
        $destino_fin = $request['destino_fin'];

        $sql = <<<EOD
select count(id_comisionado) cantidad from com_comisionado where id_comision = $id_comision and id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];


        if ($cantidad == 0) {

            $errors['mensaje'] = "El Comisionado no se encuentra programado en esta comision, no se puede asociar el destino";
            $errors['servicio'] = "destino";
        }

        $sql = <<<EOD
select count(id_destino) cantidad from com_destino where id_comision = $id_comision and id_tercero=$id_tercero and destino_ini = $destino_ini and destino_fin = $destino_fin
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];


        if ($cantidad > 0) {

            $errors['mensaje'] = "El Comisionado ya se encuentra asociado a este destino";
            $errors['servicio'] = "destino";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;




        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
